/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2004 NextApp, Inc.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

package nextapp.echo.event;

import java.io.Serializable;

/**
 * An adapter class that implements all methods of the 
 * <code>WindowListener</code> interface with empty methods.
 *
 * @see nextapp.echo.Window
 * @see nextapp.echo.event.WindowEvent
 * @see nextapp.echo.event.WindowListener
 */
public class WindowAdapter 
implements Serializable, WindowListener {

    /**
     * An empty implementation of the required <code>WindowListener<code> 
     * method.
     * 
     * @see nextapp.echo.event.WindowListener#windowClosed(WindowEvent)
     */
    public void windowClosed(WindowEvent e) { }
    
    /**
     * An empty implementation of the required <code>WindowListener<code> 
     * method.
     *
     * @see nextapp.echo.event.WindowListener#windowClosing(WindowEvent)
     */
    public void windowClosing(WindowEvent e) { }
    
    /**
     * An empty implementation of the required <code>WindowListener<code> 
     * method.
     * 
     * @see nextapp.echo.event.WindowListener#windowOpened(WindowEvent)
     */
    public void windowOpened(WindowEvent e) { }
}
