/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2004 NextApp, Inc.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

/**
 * *** WARNING *** WARNING *** WARNING *** WARNING *** WARNING *** WARNING *** WARNING *** 
 *
 * This class contains a bunch of quick and dirty test cases for Echo.
 * The purpose of this code is to TEST echo, in all kinds of different and strange
 * ways.  PLEASE DO NOT USE THIS AS AN EXAMPLE OF HOW TO WRITE SOFTWARE USING ECHO.
 * The only thing this test code is an example of is a wide variety of bad programming
 * practices.   Refer to the tutorials to see good example code.
 */

import nextapp.echo.Button;
import nextapp.echo.ButtonGroup;
import nextapp.echo.CheckBox;
import nextapp.echo.Color;
import nextapp.echo.ContentPane;
import nextapp.echo.ContainerPane;
import nextapp.echo.EchoConstants;
import nextapp.echo.EchoInstance;
import nextapp.echo.Font;
import nextapp.echo.Grid;
import nextapp.echo.HttpImageReference;
import nextapp.echo.Label;
import nextapp.echo.ListBox;
import nextapp.echo.Panel;
import nextapp.echo.PasswordField;
import nextapp.echo.RadioButton;
import nextapp.echo.SelectField;
import nextapp.echo.TextArea;
import nextapp.echo.TextField;
import nextapp.echo.Window;
import nextapp.echo.event.ActionEvent;
import nextapp.echo.event.ActionListener;
import nextapp.echo.event.WindowAdapter;
import nextapp.echo.event.WindowEvent;

import nextapp.echoservlet.EchoServer;

public class TestServlet extends EchoServer {

    public EchoInstance newInstance() {
        return new TestInstance();
    }
}

class TestInstance extends EchoInstance 
implements ActionListener {
    private static final String ADD = "a";
    private static final String REMOVE = "r";
    private static final String CHANGE_TITLE = "ct";
    private static final String OPEN_WINDOW = "ow";
    private static final String OPEN_SECOND_WINDOW = "osw";
    private static final String CLOSE_WINDOW = "cw";
    private static final String REMOTE_UPDATE = "ru";
    private static final String TOGGLE_CENTER = "tc";
    private static final String GRID_TEST = "gt";
    
    private class ChildWindow extends Window 
    implements ActionListener {
    
        private class WindowEventHandler extends WindowAdapter {
            public void windowOpened(WindowEvent e) {
                pane.add(new Label("WindowOpened called."));
                System.err.println("winopenevent");
            }
        }
    
        TextField childField = new TextField("type text here");
        ContentPane pane = new ContentPane();
    
        public ChildWindow() {
            super();

            addWindowListener(new WindowEventHandler());

            setTitle("child window");
            setContent(pane);
            pane.add(new Label("A child window"));
            Button button = new Button("Copy Text to main");
            button.setActionCommand(REMOTE_UPDATE);
            button.addActionListener(ChildWindow.this);
            pane.add(button);
            pane.add(childField);
            
            Button closeButton = new Button("close");
            closeButton.setActionCommand(CLOSE_WINDOW);
            closeButton.addActionListener(ChildWindow.this);
            pane.add(closeButton);
            
            Button openSecondWindowButton = new Button("open second child window.");
            openSecondWindowButton.setActionCommand(OPEN_SECOND_WINDOW);
            openSecondWindowButton.addActionListener(ChildWindow.this);
            pane.add(openSecondWindowButton);
        }
        
        public void actionPerformed(ActionEvent e) {
            if (REMOTE_UPDATE.equals(e.getActionCommand())) {
                windowTestLabel.setText(childField.getText());
            } else if (CLOSE_WINDOW.equals(e.getActionCommand())) {
                dispose();
            } else if (OPEN_SECOND_WINDOW.equals(e.getActionCommand())) {
                addWindow(new SecondChildWindow());
            }
        }
    }
    
    public class SecondChildWindow extends Window
    implements ActionListener {
    
        public SecondChildWindow() {
            super();

            setTitle("second child window.");
            
            ContentPane pane= new ContentPane();
            setContent(pane);

            Button closeButton = new Button("close");
            closeButton.setActionCommand(CLOSE_WINDOW);
            closeButton.addActionListener(SecondChildWindow.this);
            pane.add(closeButton);
        }
        
        public void actionPerformed(ActionEvent e) {
            if (CLOSE_WINDOW.equals(e.getActionCommand())) {
                dispose();
            }
        }
    }

    private Window w = null;
    private Button toggleButton = null;
    
    private Panel p = new Panel();
    private TextField windowTitleField = null;
    private Label windowTestLabel = null;
    private Grid.Cell centerCell;
    
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == toggleButton) {
            if (toggleButton.getText().equals("OFF")) {
                toggleButton.setText("ON");
            } else {
                toggleButton.setText("OFF");
            }
        } else if (REMOVE.equals(e.getActionCommand())) {
            p.remove(0);
        } else if (ADD.equals(e.getActionCommand())) {
            p.add(new Button(Integer.toString(p.getComponentCount())));
        } else if (CHANGE_TITLE.equals(e.getActionCommand())) {
            w.setTitle(windowTitleField.getText());
        } else if (OPEN_WINDOW == e.getActionCommand()) {
            addWindow(new ChildWindow());
        } else if (TOGGLE_CENTER.equals(e.getActionCommand())) {
            centerCell.setVisible(! centerCell.isVisible());
        } else if (GRID_TEST.equals(e.getActionCommand())) {
            addWindow(new GridTestWindow(this));
        }
    }
    
    public Window init() {
        ContentPane otherPane = new ContentPane();
        otherPane.add(new Label("The other pane"));
        windowTitleField = new TextField("Echo Debug Application I", 30);
        windowTitleField.setBackground(new Color(0xffffcf));
        windowTitleField.setBorderColor(new Color(0x00006f));
        windowTitleField.setBorderSize(3);
        windowTitleField.setBorderStyle(TextField.BORDER_SOLID);
        
        otherPane.add(windowTitleField);
        Button changeTitle = new Button("Update title");
        changeTitle.setActionCommand(CHANGE_TITLE);
        changeTitle.addActionListener(this);
        otherPane.add(changeTitle);
        
        ContentPane anotherPane  = new ContentPane();
        anotherPane.setHeight(300);
        anotherPane.setBackground(new Color(0, 0, 63));
        anotherPane.setForeground(Color.WHITE);
        
        anotherPane.add(new Label("Another pane"));
        
        Button b;
        
        b = new Button("text on top", new HttpImageReference("images/nav_left.png"));
        b.setVerticalTextPosition(EchoConstants.TOP);
        b.setRolloverEnabled(true);
        b.setRolloverIcon(new HttpImageReference("images/nav_left_rollover.png"));
        b.setRolloverBackground(Color.CYAN);
        b.setRolloverForeground(Color.RED);
        anotherPane.add(b);

        b = new Button("text on right", new HttpImageReference("images/nav_left.png"));
        b.setHorizontalTextPosition(EchoConstants.RIGHT);
        b.setRolloverEnabled(true);
        b.setRolloverIcon(new HttpImageReference("images/nav_left_rollover.png"));
        anotherPane.add(b);
        
        b = new Button("text on left", new HttpImageReference("images/nav_left.png"));
        b.setHorizontalTextPosition(EchoConstants.LEFT);
        b.setRolloverEnabled(true);
        b.setRolloverIcon(new HttpImageReference("images/nav_left_rollover.png"));
        b.setRolloverBackground(Color.CYAN);
        b.setRolloverForeground(Color.RED);
        b.setIconTextMargin(0);
        anotherPane.add(b);

        b = new Button("text on bottom", new HttpImageReference("images/nav_left.png"));
        b.setVerticalTextPosition(EchoConstants.BOTTOM);
        b.setRolloverEnabled(true);
        b.setRolloverIcon(new HttpImageReference("images/nav_left_rollover.png"));
        b.setRolloverBackground(Color.CYAN);
        b.setRolloverForeground(Color.RED);
        b.setIconTextMargin(10);
        anotherPane.add(b);
        
        CheckBox cb = new CheckBox("checkbox test", new HttpImageReference("images/nav_left.png"), true);
        anotherPane.add(cb);

        cb = new CheckBox("checkbox test", new HttpImageReference("images/nav_left.png"), true);
        cb.setHorizontalTextPosition(EchoConstants.LEFT);
        cb.setVerticalTextPosition(EchoConstants.CENTER);
        cb.setHorizontalStatePosition(EchoConstants.CENTER);
        cb.setVerticalStatePosition(EchoConstants.TOP);
        anotherPane.add(cb);

        cb = new CheckBox("checkbox test", new HttpImageReference("images/nav_left.png"), true);
        cb.setHorizontalTextPosition(EchoConstants.CENTER);
        cb.setVerticalTextPosition(EchoConstants.TOP);
        cb.setHorizontalStatePosition(EchoConstants.CENTER);
        cb.setVerticalStatePosition(EchoConstants.TOP);
        anotherPane.add(cb);
       
        cb = new CheckBox("checkbox test", new HttpImageReference("images/nav_left.png"), true);
        cb.setHorizontalTextPosition(EchoConstants.CENTER);
        cb.setVerticalTextPosition(EchoConstants.TOP);
        cb.setHorizontalStatePosition(EchoConstants.LEFT);
        cb.setVerticalStatePosition(EchoConstants.CENTER);
        cb.setRolloverBackground(Color.CYAN);
        cb.setRolloverEnabled(true);
        cb.setRolloverForeground(Color.RED);
        anotherPane.add(cb);
        
        RadioButton rb;
        ButtonGroup bg;
        
        bg = new ButtonGroup();
        rb = new RadioButton("alpha - 0");
        bg.add(rb);
        anotherPane.add(rb);
        rb = new RadioButton("alpha - 1");
        bg.add(rb);
        anotherPane.add(rb);
        rb = new RadioButton("alpha - 2");
        bg.add(rb);
        anotherPane.add(rb);
        rb = new RadioButton("alpha - 3");
        bg.add(rb);
        anotherPane.add(rb);
        
        bg = new ButtonGroup();
        rb = new RadioButton("beta - 0");
        bg.add(rb);
        anotherPane.add(rb);
        rb = new RadioButton("beta - 1");
        bg.add(rb);
        anotherPane.add(rb);
        
        SelectField sf = new SelectField(new String[]{"alpha", "bravo", "charlie", "delta", "echo", "foxtrot", "golf"});
        anotherPane.add(sf);
        
        ListBox lb = new ListBox(new String[]{"alpha", "bravo", "charlie", "delta", "echo", "foxtrot", "golf", "hotel", "india",
                "juliet", "kilo", "lima", "mike", "november", "oscar", "papa", "quebec", "romeo", "sierra", "tango", "uniform",
                "victor", "whiskey", "x-ray", "yankee", "zulu"});
        anotherPane.add(lb);
       
        ContentPane yetAnotherPane  = new ContentPane();
        yetAnotherPane.add(new Label("Yet another pane"));
        
        Grid grid = new Grid();
        
        grid.setColumnWidth(0, 50);
        grid.setColumnWidth(1, 87);
        grid.setColumnWidth(2, 65);
        grid.setBorderColor(Color.BLUE);
        grid.setBorderSize(1);
        Grid.Cell cell;
        cell = grid.add(0, 0, new Label("Alpha"));
        cell.setFlow(Grid.Cell.FLOW_DOWN | Grid.Cell.FLOW_RIGHT);
        cell.setHorizontalAlignment(EchoConstants.RIGHT);
        cell = grid.add(2, 0, new Label("Bravo"));
        cell.setFlow(Grid.Cell.FLOW_DOWN);
        cell.setVerticalAlignment(EchoConstants.BOTTOM);
        cell = grid.add(0, 2, new Label("Chralie"));
        cell.setFlow(Grid.Cell.FLOW_UP);
        cell.setVerticalAlignment(EchoConstants.TOP);
        cell = grid.add(2, 2, new Label("Delta"));
        cell.setFlow(Grid.Cell.FLOW_LEFT);
        cell.setHorizontalAlignment(EchoConstants.LEFT);
        centerCell = grid.add(1, 1, new Label("Echo"));
        yetAnotherPane.add(grid);
                
        Button toggleCenter = new Button("Toggle Center");
        toggleCenter.addActionListener(this);
        toggleCenter.setActionCommand(TOGGLE_CENTER);
        yetAnotherPane.add(toggleCenter);
        
        Button gridTest = new Button("More Grid Testing");
        gridTest.addActionListener(this);
        gridTest.setActionCommand(GRID_TEST);
        yetAnotherPane.add(gridTest);

        yetAnotherPane.add(new PasswordField(16));
        
        ContainerPane anotherContainer = new ContainerPane();
        anotherContainer.setOrientation(ContainerPane.ORIENTATION_VERTICAL);
        anotherContainer.add(otherPane);
        anotherContainer.add(anotherPane);
        anotherContainer.add(yetAnotherPane);

        ContainerPane container = new ContainerPane();
        container.add(anotherContainer);
    
        p.add(new Label("Buttons:"));
    
        w = new Window();
        w.setTitle(windowTitleField.getText());
        ContentPane cp = new ContentPane();
        container.add(cp);
        w.setContent(container);
        Label label = new Label("Hello, World!");
        toggleButton = new Button("button");
        toggleButton.addActionListener(this);
        
        TextField textField = new TextField("textfield", 30);
        textField.setBackground(new Color(63, 0, 0));
        textField.setForeground(Color.YELLOW);
        cp.add(label);
        cp.add(toggleButton);
        cp.add(textField);
        
        Button addButton = new Button("-ADD-");
        addButton.addActionListener(this);
        addButton.setActionCommand(ADD);
        addButton.setForeground(Color.RED);
        cp.add(addButton);
        
        Button removeButton = new Button("-REMOVE-");
        removeButton.setForeground(Color.RED);
        removeButton.addActionListener(this);
        removeButton.setActionCommand(REMOVE);
        cp.add(removeButton);
        
        cp.add(new Label("Line 1\n2\n3\n\n5\n\r6\r\n7\r8"));
        cp.add(new Label("<>\"&html encoding test<ABCDEF>GHIJKLMN OPQRSTUVWXYZ >&^^&&&"));
        cp.add(new Label("<foo><bar><snafu>"));
        cp.add(new Label("foo bar  foo   bar    foobar                fooobar!                 FOOObar!    "));
        
        Font font;
        Button button;
        font = new Font(Font.HELVETICA, Font.BOLD, 14);
        label = new Label("Bold");
        label.setFont(font);
        cp.add(label);
        button = new Button("Bold");
        button.setFont(font);
        cp.add(button);
        
        font = new Font(Font.HELVETICA, Font.ITALIC, 14);
        label = new Label("Italic");
        label.setFont(font);
        cp.add(label);
        button = new Button("Italic");
        button.setFont(font);
        cp.add(button);
        
        font = new Font(Font.HELVETICA, Font.UNDERLINE, 14);
        label = new Label("Underline");
        label.setFont(font);
        cp.add(label);
        button = new Button("Underline");
        button.setFont(font);
        cp.add(button);
        
        cp.add(p);
        
        TextArea textArea = new TextArea("textarea", 20, 4);
        textArea.setForeground(Color.YELLOW);
        textArea.setBackground(new Color(0, 63, 0));
        cp.add(textArea);
        
        Button newWindowButton = new Button("-NEW WINDOW-");
        newWindowButton.addActionListener(this);
        newWindowButton.setActionCommand(OPEN_WINDOW);
        newWindowButton.setBackground(Color.YELLOW);
        newWindowButton.setRolloverEnabled(true);
        newWindowButton.setRolloverBackground(Color.BLUE);
        newWindowButton.setRolloverForeground(Color.WHITE);
        cp.add(newWindowButton);
        
        Button logoButton = new Button(new HttpImageReference("images/nextapp_logo.png"));
        cp.add(logoButton);
        
        windowTestLabel = new Label("-not set yet-");
        cp.add(windowTestLabel);
        
        return w;
    }
}

class GridTestWindow extends Window {

    private EchoInstance instance;
    private Grid editableGrid;
    
    private class CellAttributesWindow extends Window 
    implements ActionListener {
        private TextField rowField;
        private TextField columnField;
        private TextField rowSpanField;
        private TextField columnSpanField;
        private TextField flowPriorityField;
        private TextField flowField;
        private Button updateButton;
        private Button deleteButton;
        private Grid.Cell editCell;
        private boolean isNew;
    
        public CellAttributesWindow(Grid.Cell editCell) {
            super();
            
            this.setDefaultCloseOperation(Window.DISPOSE_ON_CLOSE);

            this.editCell = editCell;
            isNew = editCell == null;
            
            this.setWidth(400);
            this.setHeight(300);
            
            ContentPane pane = new ContentPane();
            this.setContent(pane);
            
            if (isNew) {
                this.setTitle("Add cell");
                rowField = new TextField("0", 5);
                columnField = new TextField("0", 5);
                rowSpanField = new TextField("1", 5);
                columnSpanField = new TextField("1", 5);
                flowField = new TextField("0", 5);
                flowPriorityField = new TextField("0", 5);
                updateButton = new Button("add cell");
                updateButton.addActionListener(this);
                deleteButton = null;
            } else {
                this.setTitle("Edit cell attributes");
                rowField = null;
                columnField = null;
                rowSpanField = new TextField(Integer.toString(editCell.getRowSpan()), 5);
                columnSpanField = new TextField(Integer.toString(editCell.getColumnSpan()), 5);
                flowField = new TextField(Integer.toString(editCell.getFlow()), 5);
                flowPriorityField = new TextField(Integer.toString(editCell.getFlowPriority()), 5);
                updateButton = new Button("update cell");
                updateButton.addActionListener(this);
                deleteButton = new Button("delete cell");
                deleteButton.addActionListener(this);
            }
            
            Grid propertiesGrid = new Grid();
            propertiesGrid.setBorderColor(Color.BLACK);
            propertiesGrid.setBorderSize(1);
            propertiesGrid.setCellMargin(5);
            Grid.Cell cell;
            
            int row = 0;
            cell = propertiesGrid.add(0, row, new Label("Cell Properties"));
            cell.setFlow(Grid.Cell.FLOW_RIGHT);
            ++row;
            
            if (isNew) {
                propertiesGrid.add(0, row, new Label("Row"));
                propertiesGrid.add(1, row, rowField);
                ++row;
                propertiesGrid.add(0, row, new Label("Column"));
                propertiesGrid.add(1, row, columnField);
                ++row;
            }

            propertiesGrid.add(0, row, new Label("Row Span"));
            propertiesGrid.add(1, row, rowSpanField);
            ++row;
            propertiesGrid.add(0, row, new Label("Column Span"));
            propertiesGrid.add(1, row, columnSpanField);
            ++row;
            propertiesGrid.add(0, row, new Label("Flow (0-15)"));
            propertiesGrid.add(1, row, flowField);
            ++row;
            propertiesGrid.add(0, row, new Label("Flow Priority"));
            propertiesGrid.add(1, row, flowPriorityField);
            ++row;
            
            pane.add(propertiesGrid); 
            pane.add(updateButton);
            if (deleteButton != null) {
                pane.add(deleteButton);
            }
        }
        
        public void actionPerformed(ActionEvent e) {
            if (e.getSource() == updateButton) {
                try {
                    if (isNew) {
                        editCell = new Grid.Cell();
                    }
                    editCell.setRowSpan(Integer.parseInt(rowSpanField.getText()));
                    editCell.setColumnSpan(Integer.parseInt(columnSpanField.getText()));
                    editCell.setFlow(Integer.parseInt(flowField.getText()));
                    editCell.setFlowPriority(Integer.parseInt(flowPriorityField.getText()));
                    if (isNew) {
                        editableGrid.add(Integer.parseInt(columnField.getText()), Integer.parseInt(rowField.getText()), editCell);
                        Button editButton = new Button("(" + columnField.getText() + "," + rowField.getText() + ")");
                        editCell.add(editButton);
                        editButton.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e2) {
                                GridTestWindow.this.instance.addWindow(new CellAttributesWindow(editCell));
                            }
                        });
                    }
                    CellAttributesWindow.this.dispose();
                } catch (NumberFormatException ex) {
                    // do nothing... don't even close window.
                }
            } else if (!isNew && e.getSource() == deleteButton) {
                editableGrid.remove(editCell);
                CellAttributesWindow.this.dispose();
            }
        }
    }

    public GridTestWindow(EchoInstance instance) {
        super();
        
        setDefaultCloseOperation(Window.DISPOSE_ON_CLOSE);
        
        this.instance = instance;
        
        ContentPane pane = new ContentPane();
        setContent(pane);
        setTitle("Grid Test Window");
        
        Button addButton = new Button("add cell");
        addButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                GridTestWindow.this.instance.addWindow(new CellAttributesWindow(null));
            }
        });
        pane.add(addButton);

        editableGrid = new Grid();
        editableGrid.setBorderColor(Color.RED);
        editableGrid.setBorderSize(1);
        editableGrid.setCellMargin(5);
        pane.add(editableGrid);
    }
}
