/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2004 NextApp, Inc.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

package nextapp.testforecho;

import nextapp.echo.Button;
import nextapp.echo.ContainerPane;
import nextapp.echo.ContentPane;
import nextapp.echo.Filler;
import nextapp.echo.HttpPane;
import nextapp.echo.Label;
import nextapp.echo.TextField;
import nextapp.echo.event.ActionEvent;
import nextapp.echo.event.ActionListener;

public class HttpPaneTest extends ContainerPane {

    private class ControlPane extends ContentPane 
    implements ActionListener {
    
        private TextField uriField;

        public ControlPane() {
            setScrollBarPolicy(ContentPane.SCROLL_BAR_NEVER);

            this.add(new HelpPanel("HTTP Pane Test", "This test evaluates the functionality of the HttpPane component."));
            this.add(Filler.createVerticalStrut(20));

            this.setHeight(150);
            this.add(new Label("URI:"));
            uriField = new TextField(40);
            uriField.addActionListener(this);
            this.add(uriField);
            Button goButton = new Button("Go");
            goButton.addActionListener(this);
            this.add(goButton);
        }
        
        public void actionPerformed(ActionEvent e) {
            httpPane.setUri(uriField.getText());
        }
    }
    
    private HttpPane httpPane;
    private ControlPane controlPane;
    
    public HttpPaneTest() {
        super(ORIENTATION_VERTICAL);
        
        controlPane = new ControlPane();
        add(controlPane);

        httpPane = new HttpPane("about:blank");
        add(httpPane);
    }
}
