/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2004 NextApp, Inc.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

package nextapp.testforecho;

import nextapp.echo.AbstractButton;
import nextapp.echo.Button;
import nextapp.echo.CButton;
import nextapp.echo.CheckBox;
import nextapp.echo.ContentPane;
import nextapp.echo.Filler;
import nextapp.echo.ListBox;
import nextapp.echo.RadioButton;
import nextapp.echo.SelectField;
import nextapp.echo.TextArea;
import nextapp.echo.TextField;
import nextapp.echo.text.TextComponent;

public class TabIndexTest extends ContentPane {
    
    private static final String[] ITEMS = new String[]{"Alpha", "Bravo", "Charlie", "Delta", "Echo", "Foxtrot"};
    
    public TabIndexTest() {
        super();
        add(new HelpPanel("Style Test", "This test evaluates the functionality of the Style object."));
        add(Filler.createVerticalStrut(20));

        TestPanel testPanel = new TestPanel();
        add(testPanel);

        SelectField selectField;
        ListBox listBox;
        TextComponent text;
        AbstractButton button;
        
        text = new TextField("A text field");
        text.setTabIndex(3);
        testPanel.add("Index = 3", text);
        
        listBox = new ListBox(ITEMS);
        listBox.setTabIndex(3);
        testPanel.add("Index = 3", listBox);
        
        text = new TextField("A text field");
        text.setTabIndex(1);
        testPanel.add("Index = 1", text);

        button = new CButton("A button");
        button.setTabIndex(4);
        testPanel.add("Index = 4", button);
        
        button = new RadioButton("A radiobutton");
        button.setTabIndex(5);
        testPanel.add("Index = 5", button);
        
        text = new TextArea("A textarea");
        text.setTabIndex(7);
        testPanel.add("Index = 7", text);
        
        text = new TextArea("A textarea");
        testPanel.add("Index Unset (0)", text);
        
        button = new CheckBox("A checkbox");
        button.setTabIndex(6);
        testPanel.add("Index = 6", button);
        
        button = new Button("A button");
        button.setTabIndex(6);
        testPanel.add("Index = 6", button);
        
        button = new CButton("A button");
        testPanel.add("Index Unset (0)", button);
        
        selectField = new SelectField(ITEMS);
        selectField.setTabIndex(5);
        testPanel.add("Index = 5", selectField);
        
        text = new TextField("A text field");
        text.setTabIndex(2);
        testPanel.add("Index = 2", text);

        selectField = new SelectField(ITEMS);
        selectField.setTabIndex(4);
        testPanel.add("Index = 4", selectField);
    }
}
